package org.foo.bytebuddyexample;

import java.lang.reflect.Method;
import net.bytebuddy.implementation.bind.annotation.Argument;
import net.bytebuddy.implementation.bind.annotation.Origin;
import net.bytebuddy.implementation.bind.annotation.This;

public class SetterInterceptor {

  // Ignore Sonar warning about this method not being used anywhere other than tests. It's used by
  // ByteBuddy. Also, we don't use the value, but need to keep it to ensure that the setter matching
  // is on methods with exactly one parameter.
  public static void interceptSetter(
      @Origin Method setter, @Argument(0) Object value, @This Object entity) {
    EntityModificationUtils.registerCalledSetter(entity, setter);
  }
}
