package org.foo.bytebuddyexample;

import net.bytebuddy.implementation.bind.annotation.Argument;
import net.bytebuddy.implementation.bind.annotation.RuntimeType;
import net.bytebuddy.implementation.bind.annotation.This;

public class SaveInterceptor {

  @RuntimeType
  public static Object interceptInstanceSave(
      @Argument(0) Saver saver, @Argument(1) Flags flags, @This Object entity) {
    System.out.println(
        "Successful interception of ByteBuddy-generated instance-level synchronized save method");
    return EntityModificationUtils.saveImpl(entity, saver, flags);
  }
}
