package org.foo.bytebuddyexample;

public class Saver {

  private <T> T saveImpl(T entity, Flags flags) {
    System.out.println("Save implementation called");
    return entity;
  }

  public <T> T save(T entity, Flags flags) {
    System.out.println("Save called");
    if (EntityModificationUtils.tracksModifiedFields(entity)) {
      System.out.println("Tracks modified fields");
      return EntityModificationUtils.save(entity, this, flags);
    }
    System.out.println("Does not track modified fields");
    return saveImpl(entity, flags);
  }
}
